--import knihoven
LIBRARY IEEE;
USE IEEE.std_logic_1164.ALL;

--interface bloku je prazdny, zadne vstupy ani vystupy
ENTITY tb IS 
END ENTITY;

--vlastni implementace bloku - co je unvitr krabicky s interface def. nahore
ARCHITECTURE beh OF tb IS
  --vnitrni signaly
  SIGNAL res_i  : std_logic; --reset pro testovany obvod
  SIGNAL clk_i  : std_logic; --hodiny pro testovany obvod
  SIGNAL frq_i  : std_logic_vector (1 DOWNTO 0); --volba frekvence blikani
  SIGNAL led_i  : std_logic; --LED
  CONSTANT clk_per : time := 37.03 ns; --perioda generovanych hodin, 27 MHz

  --budeme chtit pouzivat blok led_blikac s timto interfacem   
  COMPONENT led_blikac IS 
    PORT (
      res  : IN  std_logic; --reset - vstupni signal
      clk  : IN  std_logic; --hodiny - vstupni signal
      frq  : IN  std_logic_vector (1 DOWNTO 0); --rizeni frekvence
      led  : OUT std_logic  --vystup pro ovladani diody
    );
  END COMPONENT led_blikac;   
BEGIN

  clk_generator : PROCESS --generator volne bezicich hodin
  BEGIN
    FOR ck_cnt IN 0 TO 81e6 LOOP
      clk_i <= '0';
      WAIT FOR clk_per/2;
      clk_i <= '1';
      WAIT FOR clk_per/2;
    END LOOP;
	 WAIT;
  END PROCESS clk_generator;

  evnt_res_generator : PROCESS --generator stimulu
  BEGIN
    res_i  <= '1'; --reset obvodu
    frq_i  <= "00";
    WAIT FOR 3.5 ns; --uvolni asynchronne reset
    res_i  <= '0'; --bez resetu
	 WAIT FOR 0.5 sec;
    frq_i  <= "01";
    WAIT FOR 0.5 sec;
    frq_i  <= "10";
    WAIT FOR 1.0 sec;
    frq_i  <= "11";
	 WAIT;
  END PROCESS evnt_res_generator;

  --instance DUV - verifikovaneho bloku
  i_duv : led_blikac 
    PORT MAP (
      res  => res_i,
      clk  => clk_i,
      frq  => frq_i,
      led  => led_i
    );

END ARCHITECTURE beh;
