LIBRARY IEEE;
USE IEEE.std_logic_1164.ALL;
USE IEEE.numeric_std.ALL;

ENTITY clk_glitches IS
  PORT (
    res : IN  std_logic;
    clk : IN  std_logic;
	 sig : OUT std_logic
  );
END ENTITY clk_glitches;

ARCHITECTURE rtl OF clk_glitches IS
  SIGNAL cnt_q : unsigned (7 DOWNTO 0);
  SIGNAL cnt_d : unsigned (7 DOWNTO 0);
  SIGNAL cmp   : std_logic;
  SIGNAL sig_d : std_logic;
  SIGNAL sig_q : std_logic;
BEGIN

  cnt : PROCESS (clk, res)
  BEGIN
    IF res = '1' THEN
	   cnt_q <= (OTHERS => '0');
	 ELSIF clk = '1' AND clk'EVENT THEN
	   cnt_q <= cnt_d;
	 END IF;
  END PROCESS cnt;
  cnt_d <= cnt_q + 1;
  cmp   <= '1' WHEN cnt_q = 0 ELSE '0';
  
  tg_reg : PROCESS (cmp, res)
  BEGIN
    IF res = '1' THEN
	   sig_q <= '0';
	 ELSIF cmp = '1' AND cmp'EVENT THEN
	   sig_q <= sig_d;
	 END IF;
  END PROCESS tg_reg;
  sig_d <= NOT(sig_q);
  sig <= sig_q;
  
END ARCHITECTURE rtl;

