LIBRARY IEEE;
USE IEEE.std_logic_1164.ALL;
USE IEEE.numeric_std.ALL;

ENTITY cnt IS
  GENERIC (
    width : natural := 16
  );
  PORT (
    clk : IN  std_logic;
	 res : IN  std_logic;
	 cnt : OUT unsigned (width-1 DOWNTO 0)
  );
END ENTITY cnt;

ARCHITECTURE rtl OF cnt IS
  SIGNAL cnt_q : unsigned (width-1 DOWNTO 0);
  SIGNAL cnt_d : unsigned (width-1 DOWNTO 0);
BEGIN
  cnt_reg : PROCESS (clk, res)
  BEGIN
    IF res = '1' THEN
	   cnt_q <= (OTHERS => '0');
	 ELSIF clk = '1' AND clk'EVENT THEN
	   cnt_q <= cnt_d;
	 END IF;
  END PROCESS cnt_reg;
  cnt_d <= cnt_q + 1;
  cnt   <= cnt_q;
END ARCHITECTURE rtl;