LIBRARY IEEE;
USE IEEE.std_logic_1164.ALL;
USE IEEE.numeric_std.ALL;

ENTITY ram IS 
  GENERIC (
    words : natural := 16;
	 no_b  : natural :=  4;
	 bits  : natural := 16
  );
  PORT (
    clk      : IN  std_logic;
	 wr       : IN  std_logic;
	 rd_addr  : IN  std_logic_vector (no_b-1 DOWNTO 0);
	 wr_addr  : IN  std_logic_vector (no_b-1 DOWNTO 0);
	 data_in  : IN  std_logic_vector (bits-1 DOWNTO 0);
	 data_out : OUT std_logic_vector (bits-1 DOWNTO 0)
  );
END ENTITY ram;

ARCHITECTURE rtl OF ram IS
  TYPE   tmemarr IS ARRAY (0 TO words-1) OF std_logic_vector (bits-1 DOWNTO 0);
  SIGNAL mem       : tmemarr;
  SIGNAL rd_addr_q : std_logic_vector (no_b-1 DOWNTO 0);
BEGIN


  memory : PROCESS (clk)
  BEGIN
    IF clk'event AND clk = '1' THEN
      rd_addr_q <= rd_addr;
      IF wr = '1' THEN 
		  mem(to_integer(unsigned(wr_addr))) <= data_in;
		END IF;
    END IF;
  END PROCESS;
  
  data_out <= mem(to_integer(unsigned(rd_addr_q)));
END ARCHITECTURE rtl;