LIBRARY IEEE;
USE IEEE.std_logic_1164.ALL;

ENTITY fsm IS
  PORT (
    clk   : IN  std_logic;
	 res   : IN  std_logic;
	 strt  : IN  std_logic;
	 a_gt0 : IN  std_logic;
	 we_a  : OUT std_logic_vector (1 DOWNTO 0);
	 we_b  : OUT std_logic;
	 we_c  : OUT std_logic_vector (1 DOWNTO 0)
  );
END ENTITY fsm;

ARCHITECTURE rtl OF fsm IS
  TYPE tstate IS (START, KROK1, KROK2, KROK3, KROK4, KONEC);
  SIGNAL curr_state : tstate;
  SIGNAL next_state : tstate;
BEGIN

  state_reg : PROCESS (clk, res)
  BEGIN
    IF res='1' THEN
	   curr_state <= START;
	 ELSIF clk = '1' AND clk'EVENT THEN
	   curr_state <= NEXT_STATE;
	 END IF;
  END PROCESS state_reg;

  next_state_logic : PROCESS (curr_state, a_gt0, strt)
  BEGIN
    next_state <= curr_state;
	 CASE curr_state IS
	   WHEN START  =>
		  next_state <= KROK1;
	   WHEN KROK1  =>
		  next_state <= KROK2;
	   WHEN KROK2  =>
		  next_state <= KROK3;
		WHEN KROK3  =>
		  IF a_gt0 = '0' THEN
		    next_state <= KONEC;
		  ELSE
		    next_state <= KROK4;
		  END IF;
		WHEN KROK4  =>
		  next_state <= KROK3;
		WHEN KONEC  =>
		  next_state <= KONEC;
	 END CASE;
	 IF strt = '1' THEN
	   next_state <= START;
	 END IF;
  END PROCESS next_state_logic;


  output_logic : PROCESS (curr_state)
  BEGIN
    we_a <= "00";
	 we_b <= '0';
	 we_c <= "00";
	 CASE curr_state IS
	   WHEN START  =>
	   WHEN KROK1  =>
		  we_a <= "01";
		  we_b <= '1';
		  we_c <= "01";
	   WHEN KROK2  =>
		WHEN KROK3  =>
		  we_a <= "10";
		  we_c <= "10";
		WHEN KROK4  =>
		WHEN KONEC  =>
	 END CASE;
  END PROCESS output_logic;

END ARCHITECTURE rtl;