LIBRARY IEEE;
USE IEEE.std_logic_1164.ALL;
USE IEEE.numeric_std.ALL;

ENTITY sync_rom IS
  PORT (
    clk   : IN  std_logic;
    en    : IN  std_logic;
	  addr  : IN  std_logic_vector ( 3 DOWNTO 0);
	  do    : OUT std_logic_vector (15 DOWNTO 0)
  );
END ENTITY sync_rom;

ARCHITECTURE rtl OF sync_rom IS
  TYPE   tram_array IS ARRAY (15 DOWNTO 0) OF std_logic_vector (15 DOWNTO 0);
  CONSTANT rom : tram_array := (x"0000", x"1111", x"2222", x"3323",
                                x"EDA0", x"BEDA", x"D666", x"A777",
                                x"88AF", x"4999", x"AAAA", x"BBBB",
                                x"C00C", x"D15D", x"EEEE", x"FCFF");
  SIGNAL read_addr : std_logic_vector (3 DOWNTO 0);
BEGIN

  sync_rom_impl:PROCESS (clk)
  BEGIN
    IF clk'EVENT AND clk = '1' THEN
      IF en='1' THEN
        do <= rom(to_integer(unsigned(addr)));
      END IF;
    END IF;
  END PROCESS sync_rom_impl;
END ARCHITECTURE rtl;